--- sc/source/ui/view/viewfun2.cxx.orig	2007-03-26 09:16:51.000000000 +0200
+++ sc/source/ui/view/viewfun2.cxx	2007-03-26 09:20:52.000000000 +0200
@@ -397,28 +397,42 @@
 void ScViewFunc::EnterAutoSum(const ScRangeList& rRangeList, sal_Bool bSubTotal)		// Block mit Summen fuellen
 {
 	ScDocument* pDoc = GetViewData()->GetDocument();
-	String aRef;
-	rRangeList.Format( aRef, SCA_VALID, pDoc );
-
-	String aFormula = '=';
-	ScFunctionMgr* pFuncMgr = ScGlobal::GetStarCalcFunctionMgr();
-    const ScFuncDesc* pDesc = NULL;
-    if (!bSubTotal)
-        pDesc = pFuncMgr->Get( SC_OPCODE_SUM );
-    else
-        pDesc = pFuncMgr->Get( SC_OPCODE_SUB_TOTAL );
-	if ( pDesc && pDesc->pFuncName )
-	{
-		aFormula += *pDesc->pFuncName;
-        if (bSubTotal)
-            aFormula.AppendAscii(RTL_CONSTASCII_STRINGPARAM( "(9;" ));
-        else
-            aFormula += '(';
-		aFormula += aRef;
-		aFormula += ')';
-	}
-
-	EnterBlock( aFormula, NULL );
+	ScMarkData& rMark = GetViewData()->GetMarkData();
+	ScRange range;
+	ScBaseCell* pCell = NULL;
+	CellType eType;
+
+	//get the selected range
+	rMark.GetMarkArea( range );
+	// and all the stuff needed :/
+	SCCOL nStartCol = range.aStart.Col();
+	SCROW nStartRow = range.aStart.Row();
+	SCTAB nStartTab = range.aStart.Tab();
+	SCCOL nEndCol = range.aEnd.Col();
+	SCROW nEndRow = range.aEnd.Row();
+	SCTAB nEndTab = range.aEnd.Tab();
+
+	PutInOrder( nStartCol, nEndCol );
+	PutInOrder( nStartRow, nEndRow );
+	PutInOrder( nStartTab, nEndTab );
+
+	// iterating over all cells I can find
+	// TODO : check if iterating on Tab is needed. 
+	// My guess is no, but i am really not sure of it
+	double sum = 0;
+	for ( SCTAB nTab = nStartTab; nTab <= nEndTab; nTab++ )
+		for ( SCCOL nCol = nStartCol; nCol <= nEndCol; nCol++ )
+			for ( SCROW nRow = nStartRow; nRow <= nEndRow; nRow++ ) {
+				pDoc->GetCell( nCol, nRow, nTab, pCell );
+				if (pCell && pCell->HasValueData()) {
+					eType = pCell->GetCellType();
+					if (eType == CELLTYPE_FORMULA) 
+						sum += ((ScFormulaCell*) pCell)->GetValueAlways();
+					else 
+						sum += ((ScValueCell*) pCell)->GetValue();
+				}
+			}
+	EnterBlock( rtl::OUString::valueOf(sum).getStr(), NULL );
 }
 
 
